﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace paysafe
{
    public partial class BatchPayout : Form
    {
        private List<String> currencys = new List<String>();
        private List<String> anoemail = new List<String>();
        private Dictionary<string, string> account = new Dictionary<string, string>();
        private Dictionary<string, int> namesdict = new Dictionary<string, int>();
        private string newDateString;

        public BatchPayout()
        {
            InitializeComponent();
            loadData("currencys", null);
            for (int i = 0; i < currencys.Count; i++)
            {
                comboBox1.Items.Add(currencys[i]);
            }
        }
        private void loadData(String type, String email)
        {
            var br = new System.IO.StreamReader(File.OpenRead(@"customer-list.csv"));
            string[] names = br.ReadLine().Split(',');
            namesdict.Clear();
            for (int i = 0; i < names.Length; i++)
            {
                namesdict.Add(names[i], i);
            }

            currencys.Clear();
            anoemail.Clear();
            while (!br.EndOfStream)
            {
                var line = br.ReadLine();
                if (line != "")
                {
                    var data = line.Split(',');

                    if (!type.Equals("account"))
                    {
                        if (!currencys.Contains(data[namesdict["CURRENCY"]]))
                        {
                            currencys.Add(data[namesdict["CURRENCY"]]);
                        }
                    }
                    else if (email == null)
                    {
                        anoemail.Add(data[namesdict["EMAIL"]]);
                    }
                    else if (email.Equals(data[namesdict["EMAIL"]]))
                    {
                        account.Clear();
                        account.Add("CUSTOMER_NO", data[namesdict["CUSTOMER_NO"]]);
                        account.Add("FIRST_NAME", data[namesdict["FIRST_NAME"]]);
                        account.Add("LAST_NAME", data[namesdict["LAST_NAME"]]);
                        newDateString = DateTime.ParseExact(data[namesdict["DATE_OF_BIRTH"]], "dd.mm.yyyy", CultureInfo.InvariantCulture).ToString("yyyy-mm-dd");
                        account.Add("DATE_OF_BIRTH", newDateString);
                    }
                }
            }

        }
        private String PrintXML(String XML)
        {
            String Result = "";

            MemoryStream mStream = new MemoryStream();
            XmlTextWriter writer = new XmlTextWriter(mStream, Encoding.Unicode);
            XmlDocument document = new XmlDocument();

            try
            {
                // Load the XmlDocument with the XML.
                document.LoadXml(XML);

                writer.Formatting = Formatting.Indented;

                // Write the XML into a formatting XmlTextWriter
                document.WriteContentTo(writer);
                writer.Flush();
                mStream.Flush();

                // Have to rewind the MemoryStream in order to read
                // its contents.
                mStream.Position = 0;

                // Read MemoryStream contents into a StreamReader.
                StreamReader sReader = new StreamReader(mStream);

                // Extract the text from the StreamReader.
                String FormattedXML = sReader.ReadToEnd();

                Result = FormattedXML;
            }
            catch (XmlException e)
            {
                Console.WriteLine(e.Message);
            }

            mStream.Close();
            writer.Close();

            return Result;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult dialogResult = MessageBox.Show("are you sure that you want to payout the amount of money?", "Marchant", MessageBoxButtons.YesNo);
            if (dialogResult == DialogResult.Yes)
            {
                try
                {
                    loadData("account", email.Text);
                    Payout payout = new Payout(Program.USER, Program.PASSWORD, Program.PRODUCTIVE);
                    payout.SetTransaction(money.Text, comboBox1.Text, "", Program.UTC_OFFSET);
                    payout.SetCustomer(account["CUSTOMER_NO"], email.Text, "EMAIL");
                    payout.SetCustomerDetails(account["FIRST_NAME"], account["LAST_NAME"], account["DATE_OF_BIRTH"]);
                    payout.PayoutDo(true);
                    if (payout.GetResultCode().Equals("0"))
                    {
                        textBox1.Text = "Your payout request was successful! \r\n The amount of " + money.Text + comboBox1.Text + " was transfered to your my paysafecard account.\r\n";
                    }
                    else
                    {
                        textBox1.Text = payout.getError(payout.GetErrorCode()) + "\r\n Error Code: " + payout.GetErrorCode() + "\r\n Result Code: " + payout.GetResultCode() + " \r\n Result Desc:" + payout.GetErrorCodeDescription();
                    }
                    textBox2.Text = PrintXML(payout.GetSoapResponse());
                }
                catch
                {
                }
            }
            else if (dialogResult == DialogResult.No)
            {
                //do something else
            }
        }
    }
}
