﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Xml;

namespace paysafe
{
    class PSCSOAPClient
    {
        public static StringBuilder soaprequest = new StringBuilder("");

        public string Soapcall(string url)
        {

            String respons = "";

            ServicePointManager.Expect100Continue = true;
            ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3;

            //WebRequest.DefaultWebProxy = new WebProxy("127.0.0.1:1001", true);
            WebRequest req = WebRequest.Create(url);

            HttpWebRequest httpreq = (HttpWebRequest)req;
            httpreq.Method = "POST";

            httpreq.ContentType = "text/xml; charset=utf-8";
            httpreq.Accept = "text/xml";
            httpreq.KeepAlive = false;
            httpreq.UserAgent = "paysafecard payout class(testmode) v1.0";
            httpreq.ReadWriteTimeout = 2000;
            httpreq.ProtocolVersion = HttpVersion.Version10;
            httpreq.Credentials = CredentialCache.DefaultCredentials;

            using (Stream str = httpreq.GetRequestStream())
            {
                using (StreamWriter strwriter = new StreamWriter(str, Encoding.ASCII))
                {
                    strwriter.Write(soaprequest.ToString());
                    strwriter.Close();
                }
            }

            try
            {
                HttpWebResponse res = httpreq.GetResponse() as HttpWebResponse;

                StreamReader rdr = new StreamReader(res.GetResponseStream());
                respons = rdr.ReadToEnd();

            }
            catch (WebException ex)
            {
                Console.WriteLine(ex);
            }

            return respons;
        }

        public void Addelement(Dictionary<string, string> entry)
        {
            soaprequest.Append("<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:urn=\"urn:pscservice\">");
            soaprequest.Append("<SOAP-ENV:Header/>");
            soaprequest.Append("<SOAP-ENV:Body>");
            soaprequest.Append("<urn:payout>");
            soaprequest.Append("<urn:username>" + entry["username"] + "</urn:username>");
            soaprequest.Append("<urn:password>" + entry["password"] + "</urn:password>");
            soaprequest.Append("<urn:ptid>" + entry["ptid"] + "</urn:ptid>");
            soaprequest.Append("<urn:amount>" + entry["amount"] + "</urn:amount>");
            soaprequest.Append("<urn:currency>" + entry["currency"] + "</urn:currency>");
            soaprequest.Append("<urn:customerIdType>" + entry["customerIdType"] + "</urn:customerIdType>");
            soaprequest.Append("<urn:customerId>" + entry["customerId"] + "</urn:customerId>");
            soaprequest.Append("<urn:merchantClientId>" + entry["merchantClientId"] + "</urn:merchantClientId>");
            soaprequest.Append("<urn:validationOnly>" + entry["validationOnly"] + "</urn:validationOnly>");
            soaprequest.Append("<urn:utcOffset>" + entry["utcOffset"] + "</urn:utcOffset>");
            soaprequest.Append("<urn:customerDetailsBasic>");
            soaprequest.Append("<urn:firstName>" + entry["firstName"] + "</urn:firstName>");
            soaprequest.Append("<urn:lastName>" + entry["lastName"] + "</urn:lastName>");
            soaprequest.Append("<urn:dateOfBirth>" + entry["dateOfBirth"] + "</urn:dateOfBirth>");
            soaprequest.Append("</urn:customerDetailsBasic>");
            soaprequest.Append("</urn:payout>");
            soaprequest.Append("</SOAP-ENV:Body>");
            soaprequest.Append("</SOAP-ENV:Envelope>");
        }
        public void AddelementState(Dictionary<string, string> entry)
        {
            soaprequest.Append("<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:urn=\"urn:pscservice\">");
            soaprequest.Append("<SOAP-ENV:Header/>");
            soaprequest.Append("<SOAP-ENV:Body>");
            soaprequest.Append("<urn:getPayoutState>");
            soaprequest.Append("<urn:username>" + entry["username"] + "</urn:username>");
            soaprequest.Append("<urn:password>" + entry["password"] + "</urn:password>");
            soaprequest.Append("</urn:getPayoutState>");
            soaprequest.Append("</SOAP-ENV:Body>");
            soaprequest.Append("</SOAP-ENV:Envelope>");
        }
    }
}
